/*
 * Game.java
 *
 * Created on 2008. janur 5., 12:43
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 *
 * @author USER
 */
public class Game extends Frame implements KeyListener{
	private static final long serialVersionUID = 1L;
	
	// View mc;
    MyCanvas mc;
    MyThread mt;
    Uto uto;
    Labda labda;
    boolean left, right;
    Panel menu;
    Button startButton;
    TextField tField;
    Label label;
    int elet;
    
    /** Creates a new instance of Game */
    public Game(String title) {
        super(title);
        setLayout(new BorderLayout());
     
        labda = new Labda();
        uto = (new Uto(100));
        mc = new MyCanvas();
       
        menu = new Panel();
        label = new Label("Hajraaa");
        
        startButton = new Button(" Start ");
        tField = new TextField("5");
       
        
        menu.add(tField);
        menu.add(startButton);
        menu.add(label);
        
        add(menu, BorderLayout.SOUTH);
        add(mc, BorderLayout.CENTER);
        
        setSize(600, 600);
        pack();
        setResizable(true);
        setVisible(true);
        
        addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
                	System.exit(0);
		}
        });
        startButton.addActionListener(
                        new ActionListener() 
                        {
                            public void actionPerformed(ActionEvent e){
                                    tField.setText("5"); 
                                    elet = Integer.valueOf(tField.getText());
                                    labda.setAlive(true);
                                    labda.setSpeedX(2F);
                                    labda.setSpeedY(1F);
                                    label.setText("Hajra");
                                    startButton.setLabel("Restart");
                            }
                        } 
         );
        addKeyListener(this);
        mc.addKeyListener(this);
        
        mt = new MyThread(200);
        mt.start();
    }
    public void keyPressed(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_LEFT) left = true;
		if (e.getKeyCode() == KeyEvent.VK_RIGHT) right = true;
                if (e.getKeyCode() == KeyEvent.VK_ESCAPE) System.exit(0);
    }
    public void keyReleased(KeyEvent e) {
		if (e.getKeyCode() == KeyEvent.VK_LEFT) left = false;
		if (e.getKeyCode() == KeyEvent.VK_RIGHT) right = false;
    }
    public void keyTyped(KeyEvent e){
                System.out.println(e);
    }
    
    class MyThread extends Thread {
        int mp;
        
        public MyThread(int a){
            mp = a;
            
        }
        public void run() {  // Ez a metdus most nem lenne ktelez, de ez lenne a progink motorja. Ezrt a sajt, leszrmazott osztlyunkban fell kell definilnunk
          try {
            for( ; ; ) {  // Ez az a vgtelen ciklus, ahova vissza-vissza trnk
                if(labda.isAlive())
                {
                    if(left) uto.setX(uto.getX()-1);
                    if(right) uto.setX(uto.getX()+1);
                    if( ((labda.getX()) <= 20.5 ) || ( (labda.getX() ) >= 365 ) )
                    {
                        labda.setSpeedX(-labda.getSpeedX());

                    }  
                        labda.setX(labda.getX()+labda.getSpeedX());

                    if( ((labda.getY()) <= 20.5 ) )
                    {
                        labda.setSpeedY(-labda.getSpeedY());

                    } 
                    if (labda.getY()>= 340 && labda.getY() <= 360)
                    {
                        if((labda.getX() >= uto.getX()) && (labda.getX() <= ((uto.getX()) + uto.getWidth())))
                        {
                            labda.setSpeedY(-labda.getSpeedY());
                            if(left){labda.setSpeedX(labda.getSpeedX()+1);}
                            if(right){labda.setSpeedX(labda.getSpeedX()-1);}
                        }  
                    }
                    else if(labda.getY()>= 360)
                    {
                        labda.setX(50F);
                        labda.setY(40F);        
                        elet = elet -1;
                        if(elet == 0)
                        {
                            labda.setAlive(false);
                            label.setText("Vesztettl");
                        }
                        tField.setText(""+elet);
                    }

                    labda.setY(labda.getY()+labda.getSpeedY());


                    mc.repaint();
                }
               
                sleep(10); 
            }          
            
          } catch (InterruptedException e) {}
        }
    }
  
   
    class MyCanvas extends Canvas{
		private static final long serialVersionUID = 1L;
		
			boolean init;
            public MyCanvas(){
                setSize(400,400);
                init = true;
            }
            public void paint(Graphics g){
                
              
		    g.setColor(new Color(128, 192, 96));		
                    g.fillRect(0, 0, 20, 400);
                    g.fillRect(0, 0, 400, 20);
                    g.fillRect(0, 380, 400, 20);
                    g.fillRect(380, 0,20 , 400);
                    
                    g.setColor(Color.WHITE);
                    g.fillRect(20, 20, 360, 360);
                    
                    g.setColor(Color.RED);
                    g.fillRect(uto.getX(), uto.getY(), uto.getWidth(), 20);
                    g.fillOval((int)labda.getX(),(int)labda.getY(), labda.getSize(),labda.getSize() );
                   
           }
            public void update(Graphics g) {
			paint(g);
            }
            
       }  
    
        public static void main(String[] args) {
		// Create new window object
		Game newGame = new Game("pot ZH");
	}
}
